// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef NETWORK_INTERFACE_HH
#define NETWORK_INTERFACE_HH

#include <cstddef>
#include <stdint.h>

class network_interface
{

public:

    uint32_t tx_data_old;
    bool tx_data_ready_old;
    bool mode_old;
    bool reset_old;
    bool clk_old;
    struct network_interface_iostruct{
        bool * clk;
        bool * reset;
        bool * mode;
        bool * rx_data_ready;
        uint32_t * rx_data;
        bool * tx_data_ready;
        uint32_t * tx_data;
        bool * tx_data_done;

        network_interface_iostruct():
            clk(nullptr),
            reset(nullptr),
            mode(nullptr),
            rx_data_ready(nullptr),
            rx_data(nullptr),
            tx_data_ready(nullptr),
            tx_data(nullptr),
            tx_data_done(nullptr)
        {}

        network_interface_iostruct( bool * clk_3, bool * reset_0, bool * mode_0,
             bool * rx_data_ready_0, uint32_t * rx_data_0, bool * tx_data_ready_0,
             uint32_t * tx_data_0, bool * tx_data_done_0 ):
            clk(clk_3),
            reset(reset_0),
            mode(mode_0),
            rx_data_ready(rx_data_ready_0),
            rx_data(rx_data_0),
            tx_data_ready(tx_data_ready_0),
            tx_data(tx_data_0),
            tx_data_done(tx_data_done_0)
        {}

        ~network_interface_iostruct()
        {}

        bool operator == (const network_interface_iostruct & other) const
        {
            if (clk != other.clk) return false;
            if (reset != other.reset) return false;
            if (mode != other.mode) return false;
            if (rx_data_ready != other.rx_data_ready) return false;
            if (rx_data != other.rx_data) return false;
            if (tx_data_ready != other.tx_data_ready) return false;
            if (tx_data != other.tx_data) return false;
            if (tx_data_done != other.tx_data_done) return false;
            return true;
        }
    };
    network_interface_iostruct hif_a2t_data;
    bool net_data_available;
    bool net_data_sent;
    uint32_t net_data_incoming;
    uint32_t net_data_outgoing;
    bool clkSuphif_2;
    network_interface();


    ~network_interface();


    bool net_data_available_new;
    bool net_data_sent_new;
    uint32_t net_data_incoming_new;
    uint32_t net_data_outgoing_new;
    bool clkSuphif_2_new;
    bool process_in_queue;
    bool flag_vhdl_process_UpdclkSuphif_2_executed;
    bool flag_clk;

    void vhdl_process_UpdclkSuphif_2();


    void update_input_queue( bool synch_phase = true );


    void update_event_queue();


    void flag_elaboration();


    void start_of_simulation();


    void initialize();


private:

    network_interface( const network_interface & );
    const network_interface& operator= ( const network_interface & );


};


#endif

